<?php

/*
Plugin Name: DBS-NeatlyGone
Plugin URI: http://www.dbstheme.com/?s=redirect
Description: You wanna hide it? Redirect it? I'll do it neatly!
Author: DBStheme
Author URI: http://www.dbstheme.com/
Version: 1.0.1
*/

require 'lib/DBS-Funcy.php';

$DBSFuncy = new NeatlyGone_DBSfuncy();

function NeatlyGone_addLangFile() {
	load_plugin_textdomain('NeatlyGone', false, dirname(plugin_basename( __FILE__ )) . '/lang' ); 
}
add_action('init', 'NeatlyGone_addLangFile');

function NeatlyGone_addMetabox() {
	$types = get_post_types();
	foreach( $types as $type ){
		add_meta_box( 'DBS-NeatlyGone', 'Neatly Gone', 'NeatlyGoneMetabox', $type, 'side', 'core' );
	}
}
add_action( 'add_meta_boxes', 'NeatlyGone_addMetabox' );


function NeatlyGoneMetabox() {
	$DBSFuncy = new NeatlyGone_DBSfuncy();
	$DBSFuncy -> MetaBoxCheck(array(
		'_DBS_NG_HIDE_' => __('Check if you want to hide this from posts list?', 'NeatlyGone'),
		'_DBS_NG_REDIRECT_' => __('Check if you want to redirect this to another URL?', 'NeatlyGone')
	));

	$DBSFuncy -> MetaBox(array(
		'_DBS_NG_TO_' => __('Redirect this to: (URL with http://)', 'NeatlyGone'),
		'_DBS_NG_HOW_' => __('How do you want to redirect it? (301, 302, ...)', 'NeatlyGone')
	));
}


add_action('save_post', 'checkmetaboxsave');

function checkmetaboxsave() {
		$list = array('_DBS_NG_HIDE_','_DBS_NG_REDIRECT_', '_DBS_NG_HOW_');
		foreach ($list as $name) {
			if( $_POST['funcy_' . $name] != 'on' ){
				delete_post_meta( get_the_ID(), $name );
			}
		}
}


add_action( 'wp', 'NeatlyGoneGo' );

function NeatlyGoneGo() {
	global $post;
	if( is_singular() ){
		if( get_post_meta( $post->ID, '_DBS_NG_REDIRECT_', true ) <> '' ) {
			if( get_post_meta( $post->ID, '_DBS_NG_HOW_', true ) != '' ) {
				header_remove();
				header('Location: ' . get_post_meta( $post->ID, '_DBS_NG_TO_', true ), true, get_post_meta( $post->ID, '_DBS_NG_HOW_', true ));
			} else {
				header_remove();
				header('Location: ' . get_post_meta( $post->ID, '_DBS_NG_TO_', true ));
			}
		}
	}
}


add_action('save_post','NeatlyGoneWhatToHide', 9999);

function NeatlyGoneWhatToHide() {
	if( is_admin() ){
		$HideQuery = get_posts(array( 'posts_per_page' => -1, 'meta_key' => '_DBS_NG_HIDE_', 'meta_value' => 'on', 'post_type' => 'any'));
		$tempIDs = array();
		foreach( $HideQuery as $item ){
			$tempIDs[] = $item -> ID;
		}
		update_option( 'NeatlyGoneWhatToHide', $tempIDs );
	}
}


add_action('pre_get_posts','NeatlyGoneHide');

function NeatlyGoneHide( $query ) {
		if( ! is_admin() and ! is_single() ){
		$query->set( 'post__not_in', get_option('NeatlyGoneWhatToHide'));
		return;
	}
}

?>